#!/bin/sh

# Cross-build script. This script is only meant to be run under GNU/Linux.

export MAKE="make -j8"
rm -rf build

# echo "----------------------------------------------------------------"
# echo "Building for GNU/Linux 32 bits"
# echo "----------------------------------------------------------------"
# premake4 --host=HostLinux --to=build/linux32 --os=linux gmake
# export AR="ar"
# export CC="x86_64-linux-gnu-gcc -m32"
# export CXX="x86_64-linux-gnu-g++ -m32"
# $MAKE -C build/linux32 config=debug
# $MAKE -C build/linux32 config=release

echo "----------------------------------------------------------------"
echo "Building for GNU/Linux 64 bits"
echo "----------------------------------------------------------------"
# the --os=linux is only here so premake4 generates the correct file extensions (".so")
premake4 --host=HostLinux --to=build/linux64 --os=linux gmake
export PKG_CONFIG_PATH="/usr/lib/pkgconfig"
export AR="ar"
export CC="x86_64-linux-gnu-gcc -m64"
export CXX="x86_64-linux-gnu-g++ -m64"
$MAKE -C build/linux64 config=debug &
$MAKE -C build/linux64 config=release &

echo "----------------------------------------------------------------"
echo "Building for Windows 32"
echo "----------------------------------------------------------------"
# the --os=windows is only here so premake4 generates the correct file extensions (".dll")
premake4 --host=HostWindows --to=build/w32 --os=windows gmake
export PKG_CONFIG_PATH="/usr/i686-w64-mingw32/lib/pkgconfig"
#export PATH="/usr/i686-w64-mingw32/bin:$PATH"
export AR="i686-w64-mingw32-ar"
export CC="i686-w64-mingw32-gcc -m32"
export CXX="i686-w64-mingw32-g++ -m32"
$MAKE -C build/w32 config=debug &
$MAKE -C build/w32 config=release &

# Windows 64
# echo "----------------------------------------------------------------"
# echo "Building for Windows 64"
# echo "----------------------------------------------------------------"
# premake4 --host=HostWindows --to=build/w64 --os=windows gmake
# export AR="x86_64-w64-mingw32-ar"
# export CC="x86_64-w64-mingw32-gcc -m64"
# export CXX="x86_64-w64-mingw32-g++ -m64"
# $MAKE -C build/w64 config=debug
# $MAKE -C build/w64 config=release
