/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */

#pragma once

class Delay
{
public:
  Delay();

  void Initialize();
  float Work(float sample);

  // parameters are passed as a ratio of range
  void SetParams(float time, float feedback);
  void SetTime(int numSamples);
  void SetFeedback(float feedback);

private:
  static const long MAX_DELAY = 1 << 16; // ~1s at 48kHz
  float buffer[MAX_DELAY];
  int m_nPos;

  float m_nFeedback;
  int m_nDelayLength;
};

