/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */

class AllpassDelay
{
public:
  AllpassDelay();

  void SetDelay(float fDelay);

  float Work(float input);

private:
  float m_fDelay;
  float m_fValue;
};

class Phaser
{
public:
  Phaser();

  void SetSampleRate(float fSampleRate);

  void SetMix(float fMix);
  void SetFeedback(float fb);
  void SetRange(float fMinHz, float fMaxHz);
  void SetRate(float rate);

  float Work(float input);

private:
  AllpassDelay m_Delays[6];

  float m_fDelayMin, m_fDelayMax;
  float m_Mix = 1.0f;
  float m_Feedback = 0.7f;
  float m_LfoPhase = 0.0f;
  float m_LfoInc = 0.0f;

  float m_fSampleRate = 1.0f;
  float m_fValue = 0.0f;

  float UpdateLfo();
};

