/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */

#pragma once

#include <vector>
#include <map>

class Voice;

class VoiceDispatcher
{
public:
  VoiceDispatcher(Voice* pVoices, size_t numVoices)
    : m_isMono(false),
    m_Voices(pVoices),
    m_NumVoices(numVoices)
  {
  }

  void SetMono(bool mono)
  {
    m_isMono = mono;
  }

  void NoteOn(int note, int vel);
  void NoteOff(int note, int vel);

private:
  bool m_isMono;
  Voice* const m_Voices;
  size_t const m_NumVoices;
  std::vector<int> m_PlayedNotes;
  std::map<int, int> m_NoteToVoice;
  int AllocateVoice();
};

