/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */
#pragma once

namespace EVEREST
{
class KnobComponent;

class KnobListener
{
public:
  virtual void OnValueChanged(KnobComponent* pKnob) = 0;
};

class KnobComponent : public juce::Component
{
private:
  KnobListener* const m_pListener;
  float m_fPosition, m_fDragStartPosition;
  bool m_bDragging;

public:
  KnobComponent(KnobListener* pListener = nullptr);

  bool IsDragging() const;
  void paint(Graphics& g);
  void mouseDown(const MouseEvent& e);
  void mouseUp(const MouseEvent& e);
  void mouseDrag(const MouseEvent& e);

  void setPosition(float fPosition);
  float GetPosition() const;
};
}

