/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */

#pragma once

#include <functional>
#include "lib_juce/juce.h"

using namespace std;

struct ParamAccess
{
  function<float()> getParam;
  function<void(float)> setParam;
};

class EverestParamKnob : public juce::Slider, public juce::Slider::Listener, public juce::Timer
{
public:
  EverestParamKnob(ParamAccess access);

private:
  void paint(Graphics& g);

  virtual void timerCallback();
  virtual void sliderValueChanged(juce::Slider*);

  function<void(float)> m_setParam;
  function<float()> m_getParam;
};

