// Copyright (C) 2018 - Sebastien Alaiwan
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.

#include "lib_everest.h"

#include <exception>
#include "vst_adapter.h"

struct IVst2Plugin;

#ifdef _MSC_VER
#define EVEREST_EXPORT __attribute__((dllexport))
#else
#define EVEREST_EXPORT __attribute__((visibility("default")))
#endif

// -------------------------------------------------------------------------------------------------------
extern "C"
EVEREST_EXPORT IVst2Plugin * VSTPluginMain(HostControlFunction ctrlFct)
{
  try
  {
    return EVEREST::CreateVst2Plugin(ctrlFct);
  }
  catch(std::exception const &)
  {
    return nullptr;
  }
}

#ifndef _WIN32
extern "C"
EVEREST_EXPORT IVst2Plugin * VstEntryPoint(HostControlFunction ctrlFct) asm ("main");

extern "C"
EVEREST_EXPORT IVst2Plugin * VstEntryPoint(HostControlFunction ctrlFct)
{
  return VSTPluginMain(ctrlFct);
}
#endif

// -------------------------------------------------------------------------------------------------------

