#pragma once

#include <windows.h>
#include <string>
#include <iostream>
#include <stdexcept>
#include <sstream>

inline void ThrowFatalError(std::runtime_error const& e)
{
  std::cerr << "Error : " << e.what() << std::endl;
  throw e;
}

class ComException :
  public std::runtime_error
{
private:
  static std::string MakeString(std::string const& s, HRESULT hr)
  {
    std::stringstream ss;
    ss << "(error 0x" << std::hex << hr << ")";
    return s + ss.str();
  }

public:
  ComException(std::string const& s, HRESULT hr) :
    std::runtime_error(MakeString(s, hr))
  {
  }
};

