#pragma once

#include <windows.h>
#include "ddk/ks.h"

class CKsObject
{
public:
  CKsObject(HANDLE handle);

  HANDLE GetHandle() const;

protected:
  HANDLE m_handle;

  HRESULT SetProperty(REFGUID guidPropertySet, ULONG nProperty, void* pvValue, ULONG cbValue);

  HRESULT GetProperty(REFGUID guidPropertySet, ULONG nProperty, void* pvValue, ULONG cbValue);

  HRESULT GetPropertyMulti(REFGUID guidPropertySet, ULONG nProperty, KSMULTIPLE_ITEM** ppKsMultipleItem);

  HRESULT DeviceIoControlKsProperty(KSPROPERTY& ksProperty, void* pvValue, ULONG cbValue)
  {
    ULONG ulReturned;
    return DeviceIoControl(
             m_handle,
             IOCTL_KS_PROPERTY,
             &ksProperty,
             sizeof(ksProperty),
             pvValue,
             cbValue,
             &ulReturned,
             NULL);
  }
};

