/**
 * @file util.cpp
 * @author Sebastien Alaiwan
 * @date 2011-11-20
 */

/*
 * Copyright (C) 2011 - Sebastien Alaiwan
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "util.h"
#include <cassert>
#include <mmsystem.h>
#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <tchar.h>

void DebugPrintf(LONG, LPCTSTR pszFormat, ...)
{
  TCHAR szOutput[MAX_PATH];

#ifdef _DEBUG
  va_list argList;
  va_start(argList, pszFormat);
  fflush(stdout);
  _vsntprintf(szOutput, MAX_PATH, pszFormat, argList);
  va_end(argList);
  char const* col_blue = "\x1B[01;34m";
  char const* col_def = "\x1B[0m";
  printf("[Dbg] %s%s%s\n", col_blue, szOutput, col_def);

  // printf("%s\n", szOutput);
  OutputDebugString(szOutput);
#endif
}

