#pragma once

#include <windows.h>
#include <vector>

inline bool IsEqualGUIDAligned(GUID guid1, GUID guid2)
{
  return (*(PLONGLONG)(&guid1) == *(PLONGLONG)(&guid2)) && (*((PLONGLONG)(&guid1) + 1) == *((PLONGLONG)(&guid2) + 1));
}

// Debug Trace Macro's

enum
{
  TRACE_ALWAYS = -1,
  TRACE_ERROR = 1,
  TRACE_HIGH = 2,
  TRACE_NORMAL = 3,
  TRACE_LOW = 4,
};

template<typename T, int N>
size_t ArrayLength(T(&tab)[N])
{
  return N;
}

template<typename T>
void clearVector(std::vector<T>& v)
{
  typename std::vector<T>::iterator i = v.begin();

  while(i != v.end())
  {
    delete *i++;
  }

  v.clear();
}

void DebugPrintf(LONG lDebugLevel, LPCTSTR pszFormat, ...);

template<typename T>
void Zero(T& s)
{
  memset(&s, 0, sizeof s);
}

inline bool IsValidHandle(HANDLE handle)
{
  if(handle == NULL)
  {
    return FALSE;
  }

  if(handle == INVALID_HANDLE_VALUE)
  {
    return FALSE;
  }

  return true;
}

inline void SafeCloseHandle(HANDLE& handle)
{
  if(IsValidHandle(handle))
  {
    CloseHandle(handle);
    handle = INVALID_HANDLE_VALUE;
  }
}

