/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */

#include <stdio.h>
#include <vector>
#ifdef _WIN32
#include <windows.h>
#undef min
#undef max
#endif
#include <stdarg.h>

void DebugTrace(char const* sFormat, ...)
{
  (void)sFormat;
#ifdef _DEBUG
  va_list argptr;
  va_start(argptr, sFormat);

  std::vector<char> buffer(4096);
  vsnprintf(&buffer[0], buffer.size(), sFormat, argptr);

#ifdef _WIN32
  OutputDebugString(&buffer[0]);
#else
  fprintf(stderr, "%s", &buffer[0]);
  fflush(stderr);
#endif

#endif
}

