/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */

#pragma once

struct NoDenormalScope
{
  NoDenormalScope() :
#ifdef __linux__
    oldMXCSR(__builtin_ia32_stmxcsr())
#else
    oldMXCSR(0)
#endif
  {
#ifdef __linux__
    int const newMXCSR = oldMXCSR | 0x8040; // set DAZ and FZ bits
    __builtin_ia32_ldmxcsr(newMXCSR);
#endif
  }

  ~NoDenormalScope()
  {
#ifdef __linux__
    // restore old MXCSR settings to turn denormals back on if they were on
    __builtin_ia32_ldmxcsr(oldMXCSR);
#endif
  }

  int const oldMXCSR;
};

