/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */
#include <algorithm>
#include <cassert>
#include <cstdarg>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <map>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

template<int N>
inline int portable_sprintf(char(&buffer)[N], char const* sFormat, ...)
{
  assert(0);
  return 0;
}

template<int N>
inline int portable_vsprintf(char(&buffer)[N], char const* sFormat, va_list vArgs)
{
  assert(0);
  return 0;
}

template<int N>
inline void portable_strcpy(char(&buffer)[N], char const* s)
{
  strncpy(buffer, s, N);
}

template<typename K, typename T>
ostream & operator << (ostream& o, map<K, T> const& m)
{
  o << "[";

  for(auto i = begin(m); i != end(m); ++i)
  {
    if(i != begin(m))
      o << ", ";

    o << i->first << "->" << i->second;
  }

  o << "]";

  return o;
}

inline void print_buffer(vector<uint8_t> const& r)
{
  stringstream ss;

  for(size_t i = 0; i < r.size(); ++i)
  {
    if(i != 0 && i % 16 == 0)
      ss << endl;

    ss << hex << setw(2) << setfill('0') << (unsigned int)r[i] << " ";
  }

  cout << ss.str() << endl;
}

