// Declaration of an object representing a single patch.

/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */

#pragma once

#include <vector>
#include <string>

class VirusPatch
{
private:
  std::string m_sName;

public:
  VirusPatch();

  void Parse(std::vector<uint8_t> const& sysex);
  void Parse(uint8_t const* sSysex, unsigned int iLength);
  bool Export(std::string const& sFilename) const;
  bool ExportMidiFile(std::string const& sFilename) const;
  bool Import(std::string const& sFilename);

  static bool ExportMidiFile(std::string const& sFilename, VirusPatch const* patches, int iNumPatches);

public:
  std::string GetName() const;
  int m_iPartNumber;
  std::vector<uint8_t> m_vSysex;
};

