#pragma once

#include "lib_utils/math_tools.h"

struct DspCrusher
{
  DspCrusher();
  void ProcessAudio(float** pInput, float** pOutput, long iNumSamples);

  // config
  float m_fParamClip = 1.0f;
  float m_fParamBits = 1.0f;
  float m_fParamRate = 0.50f;
  float m_fParamPostFilt = 0.9f;
  float m_fParamNonLin = 0.58;
  float m_fSampleRate = 44100;

  // set to 'true' if you modify the configuration
  bool m_bDirty;

  // auxiliary quantities: recomputed from config
  float fi2, fo2, lin1, lin2, gi, go;
  float m_fClip;
  Cycle<int> m_Cycle;

  float m_buf[10];

private:
  void recompute();
  float filterFreq(float hz) const;
};

