/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */
#pragma once

#include "lib_utils/plugin_parameters.h"

struct DelayParamSet
{
  float delaySend;
  Fraction delayClock;
  float delayTime;
  float delayFeedback;
  bool delaySync;
};

typedef ParamDesc<DelayParamSet, float> FloatParamDesc;
typedef EnumParamDesc<DelayParamSet, Fraction> ClockParamDesc;

Fraction const g_Clocks[] =
{
  { 1, 64 },
  { 1, 32 },
  { 1, 24 },
  { 3, 64 },
  { 1, 16 },
  { 1, 12 },
  { 3, 32 },
  { 1, 8 },
  { 1, 6 },
  { 3, 16 },
  { 1, 4 },
  { 1, 3 },
  { 3, 8 },
  { 1, 2 },
  { 2, 3 },
  { 3, 4 },
};

auto const DescSend = FloatParamDesc("send", 0.00f, 1.0f, &DelayParamSet::delaySend);
auto const DescClock = ClockParamDesc("clock", g_Clocks, &DelayParamSet::delayClock);
auto const DescTime = FloatParamDesc("time", 0.01f, 1.0f, &DelayParamSet::delayTime);
auto const DescFeedback = FloatParamDesc("feedback", 0.00f, 1.0f, &DelayParamSet::delayFeedback);
auto const DescSync = BoolParamDesc<DelayParamSet>("sync", &DelayParamSet::delaySync);

