/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */
#pragma once

#include "lib_everest/lib_everest.h"

namespace LibEchidna
{
EVEREST::IPlugin* CreateInstance(EVEREST::IHost* pHost);

enum SHAPE
{
  SHAPE_SQUARE,
  SHAPE_PULSE
};

enum
{
  PARAM_VOLUME,
  PARAM_MONO,
  PARAM_PORTAMENTO,

  PARAM_ENV1_ATTACK,
  PARAM_ENV1_DECAY,
  PARAM_ENV1_SUSTAIN,
  PARAM_ENV1_RELEASE,
  PARAM_ENV1_TO_FILTER,
  PARAM_ENV1_TO_VOLUME,
  PARAM_ENV1_TO_PITCH,

  PARAM_ENV2_ATTACK,
  PARAM_ENV2_DECAY,
  PARAM_ENV2_SUSTAIN,
  PARAM_ENV2_RELEASE,
  PARAM_ENV2_TO_FILTER,
  PARAM_ENV2_TO_VOLUME,
  PARAM_ENV2_TO_PITCH,

  PARAM_OSC1_SHAPE,
  PARAM_OSC1_PULSEWIDTH,
  PARAM_OSC1_DETUNE,
  PARAM_OSC1_PITCH,

  PARAM_OSC2_SHAPE,
  PARAM_OSC2_PULSEWIDTH,
  PARAM_OSC2_DETUNE,
  PARAM_OSC2_PITCH,

  PARAM_OSC_BALANCE,
  PARAM_OSC_VOLUME,
  PARAM_OSC_RINGMOD,

  PARAM_FLT1_CUTOFF,
  PARAM_FLT1_RESO,
  PARAM_FLT1_PAN,
  PARAM_FLT2_CUTOFF,
  PARAM_FLT2_RESO,
  PARAM_FLT2_PAN,
  PARAM_FLT_BALANCE,
  PARAM_FLT_PREGAIN,

  PARAM_DELAY_SEND,
  PARAM_DELAY_TIME,
  PARAM_DELAY_FEEDBACK,
  PARAM_DELAY_CLOCK,

  PARAM_LFO1_SHAPE,
  PARAM_LFO1_RATE,
  PARAM_LFO1_CLOCK,
  PARAM_LFO1_TO_FILTER,
  PARAM_LFO1_TO_VOLUME,
  PARAM_LFO1_TO_OSC1_PITCH,

  PARAM_LFO2_SHAPE,
  PARAM_LFO2_RATE,
  PARAM_LFO2_CLOCK,
  PARAM_LFO2_TO_FILTER,
  PARAM_LFO2_TO_VOLUME,
  PARAM_LFO2_TO_OSC1_PITCH,

  PARAM_VEL_TO_FILTER,
  PARAM_VEL_TO_VOLUME,
  PARAM_VEL_TO_PITCH,

  PARAM_MOD_TO_FILTER,
  PARAM_MOD_TO_VOLUME,
  PARAM_MOD_TO_PITCH,
  PARAM_MOD_TO_LFO,

  PARAM_PHASER_SEND,
  PARAM_PHASER_FREQ,
  PARAM_PHASER_DEPTH,
  PARAM_PHASER_FEEDBACK,

  NUM_PARAMS,
};
}

