// Atomizer-like plugin.

/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#pragma once

#include "lib_everest/lib_everest.h"
#include "monotrigger.h"

class AceTriggerEffect : public EVEREST::IPlugin,
  public EVEREST::IMidiListener
{
public:
  virtual void SetSampleRate(float fSampleRate);

  // Audio processing.
  virtual void ProcessAudio(float** pInputs, float** pOutputs, long iNumSamples);

  // MIDI events.
  virtual void OnTempoChange(float fTempo);

  // IMidiListener
  virtual void noteOn(int iChannel, int iNote, int iVelocity);
  virtual void noteOff(int iChannel, int iNote, int iVelocity);
  virtual void pitchBend(int, float) {};
  virtual void controlChange(int, int, int) {};

  virtual void GetId(char* pId) const
  {
    pId[0] = '@';
    pId[1] = '-';
    pId[2] = 'F';
    pId[3] = '$';
  }

  AceTriggerEffect();

private:
  MonoTrigger m_Triggers[2];
  float m_fTempo;
  float m_fSampleRate;
};

