/*
 * Copyright (C) 2017 - Sebastien Alaiwan
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 */
#pragma once

class MonoTrigger
{
public:
  MonoTrigger();
  void processSample(float* in, float* out);

  int m_iNumSamplesInLoop;

  void On(int iDivisions);
  void Off();

private:
  enum
  {
    MAX_SAMPLES_PER_CHUNK = 16384 * 10
  };

  // circular buffer
  float m_fRecordBuffer[MAX_SAMPLES_PER_CHUNK];
  int m_iRecordPosition;
  int m_iPlayPosition;

  bool m_bPlaying;
  int m_iNumSamplesInChunk;
  int m_iChunkReadPosition;
  int m_iNumMidiClocksSinceBeat;
};

