const char* presets[] =
{
  // tremolo
  R"(
#define PERIOD 1.0f / 48000.0f
#define WRAP(x) if(x >= 1.0f) x -= 1.0f

float osc;
float lfo;

float sin(float x);

float main(float input)
{
  osc += PERIOD * 240.0f;
  WRAP(osc);

  lfo += PERIOD * 10.0f;
  WRAP(lfo);

  osc += lfo * 0.01f;

  return sin(osc * 2.0f * 3.1415f);
}
)",

  // simple sine
  R"(
float osc;

float sin(float x);

float main(float input)
{
  osc += 1.0f / 48000.0f * 440.0f;
  if(osc >= 1.0f)
    osc -= 1.0f;

  return sin(osc * 2.0f * 3.1415f);
})"
};

