#include <stdio.h>
#include <dlfcn.h>

int main(int argc, char** argv)
{
  if(argc != 2)
  {
    printf("Usage: %s <library.so>\n", argv[0]);
    return 2;
  }

  auto lib = dlopen(argv[1], RTLD_NOW);

  if(!lib)
  {
    fprintf(stderr, "dlopen failure: %s\n", dlerror());
    return 1;
  }

  auto func = dlsym(lib, "VSTPluginMain");

  if(!func)
  {
    fprintf(stderr, "can't find VSTPluginMain\n");
    return 2;
  }

  dlclose(lib);
  return 0;
}

