#pragma once

struct AccessVirusParameter
{
  char m_Page;
  int m_iOffset;
  char const* m_sType;
  char const* m_sName;
};

#define VIRUS_PARAM(page, offset, type, name) AccessVirusParameter const name = { page, offset, # type, # name }

namespace VirusParam
{
VIRUS_PARAM('A', 0x05, uint, portamento);
VIRUS_PARAM('A', 0x07, uint, channel_volume);
VIRUS_PARAM('A', 0x0A, int, panorama);
VIRUS_PARAM('A', 0x11, uint, osc1_shape);
VIRUS_PARAM('A', 0x12, uint, osc1_pulse_width);
VIRUS_PARAM('A', 0x13, uint, osc1_wave_select);
VIRUS_PARAM('A', 0x14, int, osc1_semitone);
VIRUS_PARAM('A', 0x15, int, osc1_key_follow);
VIRUS_PARAM('A', 0x16, uint, osc2_shape);
VIRUS_PARAM('A', 0x17, uint, osc2_pulse_witdh);
VIRUS_PARAM('A', 0x18, uint, osc2_wave_select);
VIRUS_PARAM('A', 0x19, int, osc2_semitone);
VIRUS_PARAM('A', 0x1A, uint, osc2_detune);
VIRUS_PARAM('A', 0x1B, uint, fm_amount);
VIRUS_PARAM('A', 0x1C, uint, osc2_sync);
VIRUS_PARAM('A', 0x1D, int, osc2_filter_pitch);
VIRUS_PARAM('A', 0x1E, int, osc2_filter_fm);
VIRUS_PARAM('A', 0x1F, int, osc2_key_follow);
VIRUS_PARAM('A', 0x21, int, osc_balance);
VIRUS_PARAM('A', 0x22, uint, sub_osc_volume);
VIRUS_PARAM('A', 0x23, uint, sub_osc_shape);
VIRUS_PARAM('A', 0x24, uint, osc_volume);
VIRUS_PARAM('A', 0x25, uint, noise_volume);
VIRUS_PARAM('A', 0x26, uint, osc_ring_mod);
VIRUS_PARAM('A', 0x27, uint, noise_color);
VIRUS_PARAM('A', 0x28, uint, filter1_cutoff);
VIRUS_PARAM('A', 0x29, int, filter2_offset);
VIRUS_PARAM('A', 0x2A, uint, filter1_resonance);
VIRUS_PARAM('A', 0x2B, uint, filter2_resonance);
VIRUS_PARAM('A', 0x2C, uint, filter1_env_amount);
VIRUS_PARAM('A', 0x2D, uint, filter2_env_amount);
VIRUS_PARAM('A', 0x2E, int, filter1_key_follow);
VIRUS_PARAM('A', 0x2F, int, filter2_key_follow);
VIRUS_PARAM('A', 0x30, int, filter_balance);
VIRUS_PARAM('A', 0x31, uint, saturation_type);
VIRUS_PARAM('A', 0x33, uint, filter1_type);
VIRUS_PARAM('A', 0x34, uint, filter2_type);
VIRUS_PARAM('A', 0x35, uint, filter_routing);
VIRUS_PARAM('A', 0x36, uint, filter_attack);
VIRUS_PARAM('A', 0x37, uint, filter_decay);
VIRUS_PARAM('A', 0x38, uint, filter_sustain);
VIRUS_PARAM('A', 0x39, int, filter_sustain_slope);
VIRUS_PARAM('A', 0x3A, uint, filter_release);
VIRUS_PARAM('A', 0x3B, uint, amp_attack);
VIRUS_PARAM('A', 0x3C, uint, amp_decay);
VIRUS_PARAM('A', 0x3D, uint, amp_sustain);
VIRUS_PARAM('A', 0x3E, int, amp_sustain_slope);
VIRUS_PARAM('A', 0x3F, uint, amp_release);
VIRUS_PARAM('A', 0x43, uint, lfo1_rate);
VIRUS_PARAM('A', 0x44, uint, lfo1_shape);
VIRUS_PARAM('A', 0x45, uint, lfo1_env_mode);
VIRUS_PARAM('A', 0x46, uint, lfo1_mode);
VIRUS_PARAM('A', 0x47, int, lfo1_contour);
VIRUS_PARAM('A', 0x48, int, lfo1_key_follow);
VIRUS_PARAM('A', 0x49, uint, lfo1_trigger);
VIRUS_PARAM('A', 0x4A, int, lfo1_to_osc1_pitch);
VIRUS_PARAM('A', 0x4B, int, lfo1_to_osc2_pitch);
VIRUS_PARAM('A', 0x4C, int, lfo1_to_pulse_width);
VIRUS_PARAM('A', 0x4D, int, lfo1_to_resonance);
VIRUS_PARAM('A', 0x4E, int, lfo1_to_filter_gain);
VIRUS_PARAM('A', 0x4F, uint, lfo2_rate);
VIRUS_PARAM('A', 0x50, uint, lfo2_shape);
VIRUS_PARAM('A', 0x51, uint, lfo2_env_mode);
VIRUS_PARAM('A', 0x52, uint, lfo2_mode);
VIRUS_PARAM('A', 0x53, int, lfo2_contour);
VIRUS_PARAM('A', 0x54, int, lfo2_key_follow);
VIRUS_PARAM('A', 0x55, uint, lfo2_trigger);
VIRUS_PARAM('A', 0x56, int, lfo2_to_shape);
VIRUS_PARAM('A', 0x57, int, lfo2_to_fm_amount);
VIRUS_PARAM('A', 0x58, int, lfo2_to_cutoff1);
VIRUS_PARAM('A', 0x59, int, lfo2_to_cutoff2);
VIRUS_PARAM('A', 0x5A, int, lfo2_to_panorama);
VIRUS_PARAM('A', 0x5B, uint, patch_volume);
VIRUS_PARAM('A', 0x5D, int, transpose);
VIRUS_PARAM('A', 0x5E, uint, mono);
VIRUS_PARAM('A', 0x61, uint, unison_voices);
VIRUS_PARAM('A', 0x62, uint, unison_detune);
VIRUS_PARAM('A', 0x63, uint, unison_pan_spread);
VIRUS_PARAM('A', 0x64, int, unison_lfo_phase);
VIRUS_PARAM('A', 0x65, uint, input_mode);
VIRUS_PARAM('A', 0x66, uint, input_select);
VIRUS_PARAM('A', 0x67, uint, chorus_type);
VIRUS_PARAM('A', 0x69, uint, chorus_mix);
VIRUS_PARAM('A', 0x6A, uint, chorus_mod_rate);
VIRUS_PARAM('A', 0x6B, uint, chorus_mod_depth);
VIRUS_PARAM('A', 0x6C, uint, chorus_delay);
VIRUS_PARAM('A', 0x6D, uint, chorus_feedback);
VIRUS_PARAM('A', 0x6E, uint, chorus_mod_wave);
VIRUS_PARAM('A', 0x70, uint, delay_mode);
VIRUS_PARAM('A', 0x71, uint, delay_send);
VIRUS_PARAM('A', 0x72, uint, delay_time);
VIRUS_PARAM('A', 0x73, uint, delay_feedback);
VIRUS_PARAM('A', 0x74, uint, delay_mod_rate);
VIRUS_PARAM('A', 0x75, uint, delay_mod_depth);
VIRUS_PARAM('A', 0x76, uint, delay_mod_shape);
VIRUS_PARAM('A', 0x77, int, delay_coloration);
VIRUS_PARAM('B', 0x01, uint, arp_type);
VIRUS_PARAM('B', 0x02, uint, arp_pattern);
VIRUS_PARAM('B', 0x03, uint, arp_octaves);
VIRUS_PARAM('B', 0x04, uint, arp_hold);
VIRUS_PARAM('B', 0x05, int, arp_note_len);
VIRUS_PARAM('B', 0x06, uint, arp_swing_factor);
VIRUS_PARAM('B', 0x07, uint, lfo3_rate);
VIRUS_PARAM('B', 0x08, uint, lfo3_shape);
VIRUS_PARAM('B', 0x09, uint, lfo3_mode);
VIRUS_PARAM('B', 0x0A, int, lfo3_key_follow);
VIRUS_PARAM('B', 0x0B, uint, lfo3_dest);
VIRUS_PARAM('B', 0x0C, uint, lfo3_amount);
VIRUS_PARAM('B', 0x0D, uint, lfo3_to_fade_in);
VIRUS_PARAM('B', 0x0F, uint, arp_type_new);
VIRUS_PARAM('B', 0x10, uint, tempo);
VIRUS_PARAM('B', 0x11, uint, arp_clock);
VIRUS_PARAM('B', 0x14, uint, delay_clock);
VIRUS_PARAM('B', 0x15, uint, lfo3_clock);
VIRUS_PARAM('B', 0x19, uint, smooth_mode);
VIRUS_PARAM('B', 0x1A, int, bend_up);
VIRUS_PARAM('B', 0x1B, int, bend_down);
VIRUS_PARAM('B', 0x1C, uint, bender_scale);
VIRUS_PARAM('B', 0x1E, uint, filter1_polarity);
VIRUS_PARAM('B', 0x1F, uint, filter2_polarity);
VIRUS_PARAM('B', 0x20, uint, filter_cutoff_link);
VIRUS_PARAM('B', 0x21, uint, filter_key_follow_base);
VIRUS_PARAM('B', 0x22, uint, osc2_fm_mode);
VIRUS_PARAM('B', 0x23, uint, osc_phase_init);
VIRUS_PARAM('B', 0x24, uint, osc_punch);
VIRUS_PARAM('B', 0x26, uint, input_follower_mode);
VIRUS_PARAM('B', 0x27, uint, vocoder_mode);
VIRUS_PARAM('B', 0x29, uint, osc3_mode);
VIRUS_PARAM('B', 0x2A, uint, osc3_volume);
VIRUS_PARAM('B', 0x2B, uint, osc3_semitone);
VIRUS_PARAM('B', 0x2C, uint, osc3_detune);
VIRUS_PARAM('B', 0x2D, uint, low_eq_freq);
VIRUS_PARAM('B', 0x2E, uint, high_eq_freq);
VIRUS_PARAM('B', 0x2F, int, vel_map_osc1_shape);
VIRUS_PARAM('B', 0x30, int, vel_map_osc2_shape);
VIRUS_PARAM('B', 0x31, int, vel_map_pulse_width);
VIRUS_PARAM('B', 0x32, int, vel_map_fm_amount);
VIRUS_PARAM('B', 0x33, uint, knob1_name);
VIRUS_PARAM('B', 0x34, uint, knob2_name);
VIRUS_PARAM('B', 0x35, uint, knob3_name);
VIRUS_PARAM('B', 0x36, int, vel_map_filter1_env_amount);
VIRUS_PARAM('B', 0x37, int, vel_map_filter2_env_amount);
VIRUS_PARAM('B', 0x38, int, vel_map_filter1_resonance);
VIRUS_PARAM('B', 0x39, int, vel_map_filter2_resonance);
VIRUS_PARAM('B', 0x3A, int, surround_balance);
VIRUS_PARAM('B', 0x3C, int, vel_map_vol);
VIRUS_PARAM('B', 0x3D, int, vel_map_pan);
VIRUS_PARAM('B', 0x3E, int, knob1_function);
VIRUS_PARAM('B', 0x3F, int, knob2_function);
VIRUS_PARAM('B', 0x40, uint, matrix_slot1_src);
VIRUS_PARAM('B', 0x41, uint, matrix_slot1_dst1);
VIRUS_PARAM('B', 0x42, int, matrix_slot1_amount1);
VIRUS_PARAM('B', 0x43, uint, matrix_slot2_src);
VIRUS_PARAM('B', 0x44, uint, matrix_slot2_dst1);
VIRUS_PARAM('B', 0x45, int, matrix_slot2_amount1);
VIRUS_PARAM('B', 0x46, uint, matrix_slot2_dst2);
VIRUS_PARAM('B', 0x47, int, matrix_slot2_amount2);
VIRUS_PARAM('B', 0x48, uint, matrix_slot3_src);
VIRUS_PARAM('B', 0x49, uint, matrix_slot3_dst1);
VIRUS_PARAM('B', 0x4A, int, matrix_slot3_amount1);
VIRUS_PARAM('B', 0x4B, uint, matrix_slot3_dst2);
VIRUS_PARAM('B', 0x4C, int, matrix_slot3_amount2);
VIRUS_PARAM('B', 0x4D, uint, matrix_slot3_dst3);
VIRUS_PARAM('B', 0x4E, int, matrix_slot3_amount3);
VIRUS_PARAM('B', 0x4F, uint, lfo1_target);
VIRUS_PARAM('B', 0x50, int, lfo1_target_amount);
VIRUS_PARAM('B', 0x51, uint, lfo2_target);
VIRUS_PARAM('B', 0x52, int, lfo2_target_amount);
VIRUS_PARAM('B', 0x54, uint, phaser_stages);
VIRUS_PARAM('B', 0x55, uint, phaser_mix);
VIRUS_PARAM('B', 0x56, uint, phaser_mod_rate);
VIRUS_PARAM('B', 0x57, uint, phaser_mod_depth);
VIRUS_PARAM('B', 0x58, uint, phaser_freq);
VIRUS_PARAM('B', 0x59, uint, phaser_feedback);
VIRUS_PARAM('B', 0x5A, uint, phaser_spread);
VIRUS_PARAM('B', 0x5C, int, mid_eq_gain);
VIRUS_PARAM('B', 0x5D, int, mid_eq_freq);
VIRUS_PARAM('B', 0x5E, int, mid_eq_qfactor);
VIRUS_PARAM('B', 0x5F, int, low_eq_gain);
VIRUS_PARAM('B', 0x60, int, high_eq_gain);
VIRUS_PARAM('B', 0x61, uint, analog_boost_intensity);
VIRUS_PARAM('B', 0x62, uint, analog_boost_freq);
VIRUS_PARAM('B', 0x64, uint, dist_type);
VIRUS_PARAM('B', 0x65, uint, dist_intensity);
VIRUS_PARAM('B', 0x67, uint, matrix_slot4_src);
VIRUS_PARAM('B', 0x68, uint, matrix_slot4_dst1);
VIRUS_PARAM('B', 0x69, int, matrix_slot4_amount1);
VIRUS_PARAM('B', 0x6A, uint, matrix_slot5_src);
VIRUS_PARAM('B', 0x6B, uint, matrix_slot5_dst1);
VIRUS_PARAM('B', 0x6C, int, matrix_slot5_amount1);
VIRUS_PARAM('B', 0x6D, uint, matrix_slot6_src);
VIRUS_PARAM('B', 0x6E, uint, matrix_slot6_dst1);
VIRUS_PARAM('B', 0x6F, int, matrix_slot6_amount1);
VIRUS_PARAM('B', 0x70, char, name0);
VIRUS_PARAM('B', 0x71, char, name1);
VIRUS_PARAM('B', 0x72, char, name2);
VIRUS_PARAM('B', 0x73, char, name3);
VIRUS_PARAM('B', 0x74, char, name4);
VIRUS_PARAM('B', 0x75, char, name5);
VIRUS_PARAM('B', 0x76, char, name6);
VIRUS_PARAM('B', 0x77, char, name7);
VIRUS_PARAM('B', 0x78, char, name8);
VIRUS_PARAM('B', 0x79, char, name9);
VIRUS_PARAM('B', 0x7A, uint, filter_select);
VIRUS_PARAM('B', 0x7B, uint, name_cat1);
VIRUS_PARAM('B', 0x7C, uint, name_cat2);
VIRUS_PARAM('B', 0x7F, uint, selected_osc);
VIRUS_PARAM('C', 0x01, uint, reverb_mode);
VIRUS_PARAM('C', 0x02, uint, reverb_send);
VIRUS_PARAM('C', 0x03, uint, reverb_type);
VIRUS_PARAM('C', 0x04, uint, reverb_time);
VIRUS_PARAM('C', 0x05, uint, reverb_damping);
VIRUS_PARAM('C', 0x06, int, reverb_coloration);
VIRUS_PARAM('C', 0x07, uint, reverb_predelay);
VIRUS_PARAM('C', 0x08, uint, reverb_clock);
VIRUS_PARAM('C', 0x0A, uint, delay_type);
VIRUS_PARAM('C', 0x0C, uint, tape_delay_ratio);
VIRUS_PARAM('C', 0x0D, uint, tape_delay_left_clock);
VIRUS_PARAM('C', 0x0E, uint, tape_delay_right_clock);
VIRUS_PARAM('C', 0x11, uint, tape_delay_bandwidth);
VIRUS_PARAM('C', 0x13, uint, freq_shifter_type);
VIRUS_PARAM('C', 0x14, uint, freq_shifter_mix);
VIRUS_PARAM('C', 0x15, uint, freq_shifter_freq);
VIRUS_PARAM('C', 0x16, int, freq_shifter_phase);
VIRUS_PARAM('C', 0x17, int, freq_shifter_shape_left);
VIRUS_PARAM('C', 0x18, int, freq_shifter_shape_right);
VIRUS_PARAM('C', 0x19, uint, freq_shifter_resonance);
VIRUS_PARAM('C', 0x1A, uint, character_type);
VIRUS_PARAM('C', 0x1C, uint, knob3_function);
VIRUS_PARAM('C', 0x1E, uint, osc1_mode);
VIRUS_PARAM('C', 0x23, uint, osc2_mode);
VIRUS_PARAM('C', 0x25, int, osc1_wavetable_fspread);
VIRUS_PARAM('C', 0x2A, int, osc1_wavetable_fshift);
VIRUS_PARAM('C', 0x2B, uint, osc1_wavetable_detune);
VIRUS_PARAM('C', 0x2C, uint, osc1_wavetable_interp);
VIRUS_PARAM('C', 0x39, int, osc2_wavetable_fspread);
VIRUS_PARAM('C', 0x3E, int, osc2_wavetable_fshift);
VIRUS_PARAM('C', 0x3F, uint, osc2_wavetable_detune);
VIRUS_PARAM('C', 0x40, uint, osc2_wavetable_interp);
VIRUS_PARAM('C', 0x46, uint, dist_treble_boost);
VIRUS_PARAM('C', 0x47, uint, dist_high_cut);
VIRUS_PARAM('C', 0x48, uint, dist_mix);
VIRUS_PARAM('C', 0x49, uint, dist_quality);
VIRUS_PARAM('C', 0x4A, uint, dist_tone);
VIRUS_PARAM('C', 0x50, uint, env3_attack);
VIRUS_PARAM('C', 0x51, uint, env3_decay);
VIRUS_PARAM('C', 0x52, uint, env3_sustain);
VIRUS_PARAM('C', 0x53, int, env3_sustain_slope);
VIRUS_PARAM('C', 0x54, uint, env3_release);
VIRUS_PARAM('C', 0x55, uint, env4_attack);
VIRUS_PARAM('C', 0x56, uint, env4_decay);
VIRUS_PARAM('C', 0x57, uint, env4_sustain);
VIRUS_PARAM('C', 0x58, int, env4_sustain_slope);
VIRUS_PARAM('C', 0x59, uint, env4_release);
VIRUS_PARAM('C', 0x5A, uint, matrix_slot1_dst2);
VIRUS_PARAM('C', 0x5B, int, matrix_slot1_amount2);
VIRUS_PARAM('C', 0x5C, uint, matrix_slot1_dst3);
VIRUS_PARAM('C', 0x5D, int, matrix_slot1_amount3);
VIRUS_PARAM('C', 0x5E, uint, matrix_slot2_dst3);
VIRUS_PARAM('C', 0x5F, int, matrix_slot2_amount3);
VIRUS_PARAM('C', 0x60, uint, matrix_slot4_dst2);
VIRUS_PARAM('C', 0x61, int, matrix_slot4_amount2);
VIRUS_PARAM('C', 0x62, uint, matrix_slot4_dst3);
VIRUS_PARAM('C', 0x63, int, matrix_slot4_amount3);
VIRUS_PARAM('C', 0x64, uint, matrix_slot5_dst2);
VIRUS_PARAM('C', 0x65, int, matrix_slot5_amount2);
VIRUS_PARAM('C', 0x66, uint, matrix_slot5_dst3);
VIRUS_PARAM('C', 0x67, int, matrix_slot5_amount3);
VIRUS_PARAM('C', 0x68, uint, matrix_slot6_dst2);
VIRUS_PARAM('C', 0x69, int, matrix_slot6_amount2);
VIRUS_PARAM('C', 0x6A, uint, matrix_slot6_dst3);
VIRUS_PARAM('C', 0x6B, int, matrix_slot6_amount3);
VIRUS_PARAM('C', 0x74, uint, selected_lfo);
VIRUS_PARAM('C', 0x75, uint, selected_fx1);
VIRUS_PARAM('C', 0x76, uint, selected_fx2);
VIRUS_PARAM('C', 0x7F, uint, arp_pattern_length);
VIRUS_PARAM('D', 0x00, uint, arp_pattern_step_len_0);
VIRUS_PARAM('D', 0x01, uint, arp_pattern_step_vel_0);
VIRUS_PARAM('D', 0x02, uint, arp_pattern_step_bits_0);
VIRUS_PARAM('D', 0x03, uint, arp_pattern_step_len_1);
VIRUS_PARAM('D', 0x04, uint, arp_pattern_step_vel_1);
VIRUS_PARAM('D', 0x05, uint, arp_pattern_step_bits_1);
VIRUS_PARAM('D', 0x06, uint, arp_pattern_step_len_2);
VIRUS_PARAM('D', 0x07, uint, arp_pattern_step_vel_2);
VIRUS_PARAM('D', 0x08, uint, arp_pattern_step_bits_2);
VIRUS_PARAM('D', 0x09, uint, arp_pattern_step_len_3);
VIRUS_PARAM('D', 0x0A, uint, arp_pattern_step_vel_3);
VIRUS_PARAM('D', 0x0B, uint, arp_pattern_step_bits_3);
VIRUS_PARAM('D', 0x0C, uint, arp_pattern_step_len_4);
VIRUS_PARAM('D', 0x0D, uint, arp_pattern_step_vel_4);
VIRUS_PARAM('D', 0x0E, uint, arp_pattern_step_bits_4);
VIRUS_PARAM('D', 0x0F, uint, arp_pattern_step_len_5);
VIRUS_PARAM('D', 0x10, uint, arp_pattern_step_vel_5);
VIRUS_PARAM('D', 0x11, uint, arp_pattern_step_bits_5);
VIRUS_PARAM('D', 0x12, uint, arp_pattern_step_len_6);
VIRUS_PARAM('D', 0x13, uint, arp_pattern_step_vel_6);
VIRUS_PARAM('D', 0x14, uint, arp_pattern_step_bits_6);
VIRUS_PARAM('D', 0x15, uint, arp_pattern_step_len_7);
VIRUS_PARAM('D', 0x16, uint, arp_pattern_step_vel_7);
VIRUS_PARAM('D', 0x17, uint, arp_pattern_step_bits_7);
VIRUS_PARAM('D', 0x18, uint, arp_pattern_step_len_8);
VIRUS_PARAM('D', 0x19, uint, arp_pattern_step_vel_8);
VIRUS_PARAM('D', 0x1A, uint, arp_pattern_step_bits_8);
VIRUS_PARAM('D', 0x1B, uint, arp_pattern_step_len_9);
VIRUS_PARAM('D', 0x1C, uint, arp_pattern_step_vel_9);
VIRUS_PARAM('D', 0x1D, uint, arp_pattern_step_bits_9);
VIRUS_PARAM('D', 0x1E, uint, arp_pattern_step_len_10);
VIRUS_PARAM('D', 0x1F, uint, arp_pattern_step_vel_10);
VIRUS_PARAM('D', 0x20, uint, arp_pattern_step_bits_10);
VIRUS_PARAM('D', 0x21, uint, arp_pattern_step_len_11);
VIRUS_PARAM('D', 0x22, uint, arp_pattern_step_vel_11);
VIRUS_PARAM('D', 0x23, uint, arp_pattern_step_bits_11);
VIRUS_PARAM('D', 0x24, uint, arp_pattern_step_len_12);
VIRUS_PARAM('D', 0x25, uint, arp_pattern_step_vel_12);
VIRUS_PARAM('D', 0x26, uint, arp_pattern_step_bits_12);
VIRUS_PARAM('D', 0x27, uint, arp_pattern_step_len_13);
VIRUS_PARAM('D', 0x28, uint, arp_pattern_step_vel_13);
VIRUS_PARAM('D', 0x29, uint, arp_pattern_step_bits_13);
VIRUS_PARAM('D', 0x2A, uint, arp_pattern_step_len_14);
VIRUS_PARAM('D', 0x2B, uint, arp_pattern_step_vel_14);
VIRUS_PARAM('D', 0x2C, uint, arp_pattern_step_bits_14);
VIRUS_PARAM('D', 0x2D, uint, arp_pattern_step_len_15);
VIRUS_PARAM('D', 0x2E, uint, arp_pattern_step_vel_15);
VIRUS_PARAM('D', 0x2F, uint, arp_pattern_step_bits_15);
VIRUS_PARAM('D', 0x30, uint, arp_pattern_step_len_16);
VIRUS_PARAM('D', 0x31, uint, arp_pattern_step_vel_16);
VIRUS_PARAM('D', 0x32, uint, arp_pattern_step_bits_16);
VIRUS_PARAM('D', 0x33, uint, arp_pattern_step_len_17);
VIRUS_PARAM('D', 0x34, uint, arp_pattern_step_vel_17);
VIRUS_PARAM('D', 0x35, uint, arp_pattern_step_bits_17);
VIRUS_PARAM('D', 0x36, uint, arp_pattern_step_len_18);
VIRUS_PARAM('D', 0x37, uint, arp_pattern_step_vel_18);
VIRUS_PARAM('D', 0x38, uint, arp_pattern_step_bits_18);
VIRUS_PARAM('D', 0x39, uint, arp_pattern_step_len_19);
VIRUS_PARAM('D', 0x3A, uint, arp_pattern_step_vel_19);
VIRUS_PARAM('D', 0x3B, uint, arp_pattern_step_bits_19);
VIRUS_PARAM('D', 0x3C, uint, arp_pattern_step_len_20);
VIRUS_PARAM('D', 0x3D, uint, arp_pattern_step_vel_20);
VIRUS_PARAM('D', 0x3E, uint, arp_pattern_step_bits_20);
VIRUS_PARAM('D', 0x3F, uint, arp_pattern_step_len_21);
VIRUS_PARAM('D', 0x40, uint, arp_pattern_step_vel_21);
VIRUS_PARAM('D', 0x41, uint, arp_pattern_step_bits_21);
VIRUS_PARAM('D', 0x42, uint, arp_pattern_step_len_22);
VIRUS_PARAM('D', 0x43, uint, arp_pattern_step_vel_22);
VIRUS_PARAM('D', 0x44, uint, arp_pattern_step_bits_22);
VIRUS_PARAM('D', 0x45, uint, arp_pattern_step_len_23);
VIRUS_PARAM('D', 0x46, uint, arp_pattern_step_vel_23);
VIRUS_PARAM('D', 0x47, uint, arp_pattern_step_bits_23);
VIRUS_PARAM('D', 0x48, uint, arp_pattern_step_len_24);
VIRUS_PARAM('D', 0x49, uint, arp_pattern_step_vel_24);
VIRUS_PARAM('D', 0x4A, uint, arp_pattern_step_bits_24);
VIRUS_PARAM('D', 0x4B, uint, arp_pattern_step_len_25);
VIRUS_PARAM('D', 0x4C, uint, arp_pattern_step_vel_25);
VIRUS_PARAM('D', 0x4D, uint, arp_pattern_step_bits_25);
VIRUS_PARAM('D', 0x4E, uint, arp_pattern_step_len_26);
VIRUS_PARAM('D', 0x4F, uint, arp_pattern_step_vel_26);
VIRUS_PARAM('D', 0x50, uint, arp_pattern_step_bits_26);
VIRUS_PARAM('D', 0x51, uint, arp_pattern_step_len_27);
VIRUS_PARAM('D', 0x52, uint, arp_pattern_step_vel_27);
VIRUS_PARAM('D', 0x53, uint, arp_pattern_step_bits_27);
VIRUS_PARAM('D', 0x54, uint, arp_pattern_step_len_28);
VIRUS_PARAM('D', 0x55, uint, arp_pattern_step_vel_28);
VIRUS_PARAM('D', 0x56, uint, arp_pattern_step_bits_28);
VIRUS_PARAM('D', 0x57, uint, arp_pattern_step_len_29);
VIRUS_PARAM('D', 0x58, uint, arp_pattern_step_vel_29);
VIRUS_PARAM('D', 0x59, uint, arp_pattern_step_bits_29);
VIRUS_PARAM('D', 0x5A, uint, arp_pattern_step_len_30);
VIRUS_PARAM('D', 0x5B, uint, arp_pattern_step_vel_30);
VIRUS_PARAM('D', 0x5C, uint, arp_pattern_step_bits_30);
VIRUS_PARAM('D', 0x5D, uint, arp_pattern_step_len_31);
VIRUS_PARAM('D', 0x5E, uint, arp_pattern_step_vel_31);
VIRUS_PARAM('D', 0x5F, uint, arp_pattern_step_bits_31);
}

#undef VIRUS_PARAM

AccessVirusParameter const g_PatchParameters[] =
{
  VirusParam::portamento,
  VirusParam::panorama,
  VirusParam::osc1_shape,
  VirusParam::osc1_pulse_width,
  VirusParam::osc1_wave_select,
  VirusParam::osc1_semitone,
  VirusParam::osc1_key_follow,
  VirusParam::osc2_shape,
  VirusParam::osc2_pulse_witdh,
  VirusParam::osc2_wave_select,
  VirusParam::osc2_semitone,
  VirusParam::osc2_detune,
  VirusParam::fm_amount,
  VirusParam::osc2_sync,
  VirusParam::osc2_filter_pitch,
  VirusParam::osc2_filter_fm,
  VirusParam::osc2_key_follow,
  VirusParam::osc_balance,
  VirusParam::sub_osc_volume,
  VirusParam::sub_osc_shape,
  VirusParam::osc_volume,
  VirusParam::noise_volume,
  VirusParam::osc_ring_mod,
  VirusParam::noise_color,
  VirusParam::filter1_cutoff,
  VirusParam::filter2_offset,
  VirusParam::filter1_resonance,
  VirusParam::filter2_resonance,
  VirusParam::filter1_env_amount,
  VirusParam::filter2_env_amount,
  VirusParam::filter1_key_follow,
  VirusParam::filter2_key_follow,
  VirusParam::filter_balance,
  VirusParam::saturation_type,
  VirusParam::filter1_type,
  VirusParam::filter2_type,
  VirusParam::filter_routing,
  VirusParam::filter_attack,
  VirusParam::filter_decay,
  VirusParam::filter_sustain,
  VirusParam::filter_sustain_slope,
  VirusParam::filter_release,
  VirusParam::amp_attack,
  VirusParam::amp_decay,
  VirusParam::amp_sustain,
  VirusParam::amp_sustain_slope,
  VirusParam::amp_release,
  VirusParam::lfo1_rate,
  VirusParam::lfo1_shape,
  VirusParam::lfo1_env_mode,
  VirusParam::lfo1_mode,
  VirusParam::lfo1_contour,
  VirusParam::lfo1_key_follow,
  VirusParam::lfo1_trigger,
  VirusParam::lfo1_to_osc1_pitch,
  VirusParam::lfo1_to_osc2_pitch,
  VirusParam::lfo1_to_pulse_width,
  VirusParam::lfo1_to_resonance,
  VirusParam::lfo1_to_filter_gain,
  VirusParam::lfo2_rate,
  VirusParam::lfo2_shape,
  VirusParam::lfo2_env_mode,
  VirusParam::lfo2_mode,
  VirusParam::lfo2_contour,
  VirusParam::lfo2_key_follow,
  VirusParam::lfo2_trigger,
  VirusParam::lfo2_to_shape,
  VirusParam::lfo2_to_fm_amount,
  VirusParam::lfo2_to_cutoff1,
  VirusParam::lfo2_to_cutoff2,
  VirusParam::lfo2_to_panorama,
  VirusParam::patch_volume,
  VirusParam::transpose,
  VirusParam::mono,
  VirusParam::unison_voices,
  VirusParam::unison_detune,
  VirusParam::unison_pan_spread,
  VirusParam::unison_lfo_phase,
  VirusParam::input_mode,
  VirusParam::input_select,
  VirusParam::chorus_type,
  VirusParam::chorus_mix,
  VirusParam::chorus_mod_rate,
  VirusParam::chorus_mod_depth,
  VirusParam::chorus_delay,
  VirusParam::chorus_feedback,
  VirusParam::chorus_mod_wave,
  VirusParam::delay_mode,
  VirusParam::delay_send,
  VirusParam::delay_time,
  VirusParam::delay_feedback,
  VirusParam::delay_mod_rate,
  VirusParam::delay_mod_depth,
  VirusParam::delay_mod_shape,
  VirusParam::delay_coloration,

  VirusParam::arp_type,
  VirusParam::arp_pattern,
  VirusParam::arp_octaves,
  VirusParam::arp_hold,
  VirusParam::arp_note_len,
  VirusParam::arp_swing_factor,
  VirusParam::lfo3_rate,
  VirusParam::lfo3_shape,
  VirusParam::lfo3_mode,
  VirusParam::lfo3_key_follow,
  VirusParam::lfo3_dest,
  VirusParam::lfo3_amount,
  VirusParam::lfo3_to_fade_in,
  VirusParam::arp_type_new,
  VirusParam::arp_clock,
  VirusParam::delay_clock,
  VirusParam::lfo3_clock,
  VirusParam::smooth_mode,
  VirusParam::bend_up,
  VirusParam::bend_down,
  VirusParam::bender_scale,
  VirusParam::filter1_polarity,
  VirusParam::filter2_polarity,
  VirusParam::filter_cutoff_link,
  VirusParam::filter_key_follow_base,
  VirusParam::osc2_fm_mode,
  VirusParam::osc_phase_init,
  VirusParam::osc_punch,
  VirusParam::input_follower_mode,
  VirusParam::vocoder_mode,
  VirusParam::osc3_mode,
  VirusParam::osc3_volume,
  VirusParam::osc3_semitone,
  VirusParam::osc3_detune,
  VirusParam::low_eq_freq,
  VirusParam::high_eq_freq,
  VirusParam::vel_map_osc1_shape,
  VirusParam::vel_map_osc2_shape,
  VirusParam::vel_map_pulse_width,
  VirusParam::vel_map_fm_amount,
  VirusParam::knob1_name,
  VirusParam::knob2_name,
  VirusParam::knob3_name,
  VirusParam::vel_map_filter1_env_amount,
  VirusParam::vel_map_filter2_env_amount,
  VirusParam::vel_map_filter1_resonance,
  VirusParam::vel_map_filter2_resonance,
  VirusParam::surround_balance,
  VirusParam::vel_map_vol,
  VirusParam::vel_map_pan,
  VirusParam::knob1_function,
  VirusParam::knob2_function,
  VirusParam::matrix_slot1_src,
  VirusParam::matrix_slot1_dst1,
  VirusParam::matrix_slot1_amount1,
  VirusParam::matrix_slot2_src,
  VirusParam::matrix_slot2_dst1,
  VirusParam::matrix_slot2_amount1,
  VirusParam::matrix_slot2_dst2,
  VirusParam::matrix_slot2_amount2,
  VirusParam::matrix_slot3_src,
  VirusParam::matrix_slot3_dst1,
  VirusParam::matrix_slot3_amount1,
  VirusParam::matrix_slot3_dst2,
  VirusParam::matrix_slot3_amount2,
  VirusParam::matrix_slot3_dst3,
  VirusParam::matrix_slot3_amount3,
  VirusParam::lfo1_target,
  VirusParam::lfo1_target_amount,
  VirusParam::lfo2_target,
  VirusParam::lfo2_target_amount,
  VirusParam::phaser_stages,
  VirusParam::phaser_mix,
  VirusParam::phaser_mod_rate,
  VirusParam::phaser_mod_depth,
  VirusParam::phaser_freq,
  VirusParam::phaser_feedback,
  VirusParam::phaser_spread,
  VirusParam::mid_eq_gain,
  VirusParam::mid_eq_freq,
  VirusParam::mid_eq_qfactor,
  VirusParam::low_eq_gain,
  VirusParam::high_eq_gain,
  VirusParam::analog_boost_intensity,
  VirusParam::analog_boost_freq,
  VirusParam::dist_type,
  VirusParam::dist_intensity,
  VirusParam::matrix_slot4_src,
  VirusParam::matrix_slot4_dst1,
  VirusParam::matrix_slot4_amount1,
  VirusParam::matrix_slot5_src,
  VirusParam::matrix_slot5_dst1,
  VirusParam::matrix_slot5_amount1,
  VirusParam::matrix_slot6_src,
  VirusParam::matrix_slot6_dst1,
  VirusParam::matrix_slot6_amount1,
  VirusParam::name0,
  VirusParam::name1,
  VirusParam::name2,
  VirusParam::name3,
  VirusParam::name4,
  VirusParam::name5,
  VirusParam::name6,
  VirusParam::name7,
  VirusParam::name8,
  VirusParam::name9,
  VirusParam::name_cat1,
  VirusParam::name_cat2,
  VirusParam::selected_osc,

  VirusParam::reverb_mode,
  VirusParam::reverb_send,
  VirusParam::reverb_type,
  VirusParam::reverb_time,
  VirusParam::reverb_damping,
  VirusParam::reverb_coloration,
  VirusParam::reverb_predelay,
  VirusParam::reverb_clock,
  VirusParam::delay_type,
  VirusParam::tape_delay_ratio,
  VirusParam::tape_delay_left_clock,
  VirusParam::tape_delay_right_clock,
  VirusParam::tape_delay_bandwidth,
  VirusParam::freq_shifter_type,
  VirusParam::freq_shifter_mix,
  VirusParam::freq_shifter_freq,
  VirusParam::freq_shifter_phase,
  VirusParam::freq_shifter_shape_left,
  VirusParam::freq_shifter_shape_right,
  VirusParam::freq_shifter_resonance,
  VirusParam::character_type,
  VirusParam::knob3_function,
  VirusParam::osc1_mode,
  VirusParam::osc2_mode,
  VirusParam::osc1_wavetable_fspread,
  VirusParam::osc1_wavetable_fshift,
  VirusParam::osc1_wavetable_detune,
  VirusParam::osc1_wavetable_interp,
  VirusParam::osc2_wavetable_fspread,
  VirusParam::osc2_wavetable_fshift,
  VirusParam::osc2_wavetable_detune,
  VirusParam::osc2_wavetable_interp,
  VirusParam::dist_treble_boost,
  VirusParam::dist_high_cut,
  VirusParam::dist_mix,
  VirusParam::dist_quality,
  VirusParam::dist_tone,
  VirusParam::env3_attack,
  VirusParam::env3_decay,
  VirusParam::env3_sustain,
  VirusParam::env3_sustain_slope,
  VirusParam::env3_release,
  VirusParam::env4_attack,
  VirusParam::env4_decay,
  VirusParam::env4_sustain,
  VirusParam::env4_sustain_slope,
  VirusParam::env4_release,
  /*
     VirusParam::matrix_slot1_dst2,
     VirusParam::matrix_slot1_amount2,
     VirusParam::matrix_slot1_dst3,
     VirusParam::matrix_slot1_amount3,
     VirusParam::matrix_slot2_dst3,
     VirusParam::matrix_slot2_amount3,
     VirusParam::matrix_slot4_dst2,
     VirusParam::matrix_slot4_amount2,
     VirusParam::matrix_slot4_dst3,
     VirusParam::matrix_slot4_amount3,
     VirusParam::matrix_slot5_dst2,
     VirusParam::matrix_slot5_amount2,
     VirusParam::matrix_slot5_dst3,
     VirusParam::matrix_slot5_amount3,
     VirusParam::matrix_slot6_dst2,
     VirusParam::matrix_slot6_amount2,
     VirusParam::matrix_slot6_dst3,
     VirusParam::matrix_slot6_amount3,
     VirusParam::arp_pattern_length,
     VirusParam::arp_pattern_step_len_0,
     VirusParam::arp_pattern_step_vel_0,
     VirusParam::arp_pattern_step_bits_0,
     VirusParam::arp_pattern_step_len_1,
     VirusParam::arp_pattern_step_vel_1,
     VirusParam::arp_pattern_step_bits_1,
     VirusParam::arp_pattern_step_len_2,
     VirusParam::arp_pattern_step_vel_2,
     VirusParam::arp_pattern_step_bits_2,
     VirusParam::arp_pattern_step_len_3,
     VirusParam::arp_pattern_step_vel_3,
     VirusParam::arp_pattern_step_bits_3,
     VirusParam::arp_pattern_step_len_4,
     VirusParam::arp_pattern_step_vel_4,
     VirusParam::arp_pattern_step_bits_4,
     VirusParam::arp_pattern_step_len_5,
     VirusParam::arp_pattern_step_vel_5,
     VirusParam::arp_pattern_step_bits_5,
     VirusParam::arp_pattern_step_len_6,
     VirusParam::arp_pattern_step_vel_6,
     VirusParam::arp_pattern_step_bits_6,
     VirusParam::arp_pattern_step_len_7,
     VirusParam::arp_pattern_step_vel_7,
     VirusParam::arp_pattern_step_bits_7,
     VirusParam::arp_pattern_step_len_8,
     VirusParam::arp_pattern_step_vel_8,
     VirusParam::arp_pattern_step_bits_8,
     VirusParam::arp_pattern_step_len_9,
     VirusParam::arp_pattern_step_vel_9,
     VirusParam::arp_pattern_step_bits_9,
     VirusParam::arp_pattern_step_len_10,
     VirusParam::arp_pattern_step_vel_10,
     VirusParam::arp_pattern_step_bits_10,
     VirusParam::arp_pattern_step_len_11,
     VirusParam::arp_pattern_step_vel_11,
     VirusParam::arp_pattern_step_bits_11,
     VirusParam::arp_pattern_step_len_12,
     VirusParam::arp_pattern_step_vel_12,
     VirusParam::arp_pattern_step_bits_12,
     VirusParam::arp_pattern_step_len_13,
     VirusParam::arp_pattern_step_vel_13,
     VirusParam::arp_pattern_step_bits_13,
     VirusParam::arp_pattern_step_len_14,
     VirusParam::arp_pattern_step_vel_14,
     VirusParam::arp_pattern_step_bits_14,
     VirusParam::arp_pattern_step_len_15,
     VirusParam::arp_pattern_step_vel_15,
     VirusParam::arp_pattern_step_bits_15,
     VirusParam::arp_pattern_step_len_16,
     VirusParam::arp_pattern_step_vel_16,
     VirusParam::arp_pattern_step_bits_16,
     VirusParam::arp_pattern_step_len_17,
     VirusParam::arp_pattern_step_vel_17,
     VirusParam::arp_pattern_step_bits_17,
     VirusParam::arp_pattern_step_len_18,
     VirusParam::arp_pattern_step_vel_18,
     VirusParam::arp_pattern_step_bits_18,
     VirusParam::arp_pattern_step_len_19,
     VirusParam::arp_pattern_step_vel_19,
     VirusParam::arp_pattern_step_bits_19,
     VirusParam::arp_pattern_step_len_20,
     VirusParam::arp_pattern_step_vel_20,
     VirusParam::arp_pattern_step_bits_20,
     VirusParam::arp_pattern_step_len_21,
     VirusParam::arp_pattern_step_vel_21,
     VirusParam::arp_pattern_step_bits_21,
     VirusParam::arp_pattern_step_len_22,
     VirusParam::arp_pattern_step_vel_22,
     VirusParam::arp_pattern_step_bits_22,
     VirusParam::arp_pattern_step_len_23,
     VirusParam::arp_pattern_step_vel_23,
     VirusParam::arp_pattern_step_bits_23,
     VirusParam::arp_pattern_step_len_24,
     VirusParam::arp_pattern_step_vel_24,
     VirusParam::arp_pattern_step_bits_24,
     VirusParam::arp_pattern_step_len_25,
     VirusParam::arp_pattern_step_vel_25,
     VirusParam::arp_pattern_step_bits_25,
     VirusParam::arp_pattern_step_len_26,
     VirusParam::arp_pattern_step_vel_26,
     VirusParam::arp_pattern_step_bits_26,
     VirusParam::arp_pattern_step_len_27,
     VirusParam::arp_pattern_step_vel_27,
     VirusParam::arp_pattern_step_bits_27,
     VirusParam::arp_pattern_step_len_28,
     VirusParam::arp_pattern_step_vel_28,
     VirusParam::arp_pattern_step_bits_28,
     VirusParam::arp_pattern_step_len_29,
     VirusParam::arp_pattern_step_vel_29,
     VirusParam::arp_pattern_step_bits_29,
     VirusParam::arp_pattern_step_len_30,
     VirusParam::arp_pattern_step_vel_30,
     VirusParam::arp_pattern_step_bits_30,
     VirusParam::arp_pattern_step_len_31,
     VirusParam::arp_pattern_step_vel_31,
     VirusParam::arp_pattern_step_bits_31,
   */
};

